'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.each = undefined;

var _range = require('../iter/range');

var _options = require('../options');

var _utility = require('../utility');

var each = exports.each = function each(tArray, tConsumer) {
    var options = arguments.length <= 2 || arguments[2] === undefined ? _options.DEFAULT_OPTIONS : arguments[2];

    (0, _utility.assertNonemptyArray)(tArray);
    (0, _utility.assertFn)(tConsumer);
    var indexConsumer = function indexConsumer(index) {
        tConsumer.call(this, tArray[index], index);
    };
    return (0, _range.range)(indexConsumer, tArray.length, options).catch(function (error) {
        throw (0, _utility.extend)(error, { item: tArray[error.index] });
    });
};