'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.reduce = undefined;

var _each = require('./each');

var _options = require('../options');

var _utility = require('../utility');

var reduce = exports.reduce = function reduce(tArray, tReducer) {
    var options = arguments.length <= 2 || arguments[2] === undefined ? _options.DEFAULT_OPTIONS : arguments[2];
    var memo = arguments[3];

    (0, _utility.assertNonemptyArray)(tArray);
    (0, _utility.assertFn)(tReducer);
    var skipFirst = memo === undefined;
    if (skipFirst) {
        memo = tArray[0];
    }
    var tConsumer = function tConsumer(tItem, index) {
        if (skipFirst && index === 0) {
            return;
        }
        memo = tReducer.call(this, memo, tItem, index, tArray);
    };
    return (0, _each.each)(tArray, tConsumer, options).then(function () {
        return memo;
    });
};