'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.generator = undefined;

var _options = require('./options');

var _utility = require('./utility');

var _pause = require('./pause');

// return values from the range "start" to "final"
// synchronously when between intervals of size "chunk".
//
// on the boundary, return a promise that resolves in "delay" milliseconds.
//
// an error will be thrown in case an iterator is advanced before this promise resolves.
var __chunkify__ = regeneratorRuntime.mark(function __chunkify__(start, final, options) {
    var chunk, delay, paused, pause, index;
    return regeneratorRuntime.wrap(function __chunkify__$(_context2) {
        while (1) {
            switch (_context2.prev = _context2.next) {
                case 0:
                    chunk = options.chunk;
                    delay = options.delay;
                    paused = false;
                    pause = regeneratorRuntime.mark(function pause() {
                        return regeneratorRuntime.wrap(function pause$(_context) {
                            while (1) {
                                switch (_context.prev = _context.next) {
                                    case 0:
                                        paused = true;
                                        _context.next = 3;
                                        return _pause.Pause.for(delay).resume(function () {
                                            paused = false;
                                        });

                                    case 3:
                                    case 'end':
                                        return _context.stop();
                                }
                            }
                        }, pause, this);
                    });
                    index = start;

                case 5:
                    if (!(index < final)) {
                        _context2.next = 15;
                        break;
                    }

                    if (!(index > start && index % (start + chunk) === 0)) {
                        _context2.next = 8;
                        break;
                    }

                    return _context2.delegateYield(pause(), 't0', 8);

                case 8:
                    if (!paused) {
                        _context2.next = 10;
                        break;
                    }

                    throw new Error('paused at index ' + index + '; wait ' + delay + ' milliseconds before further invocations of .next()');

                case 10:
                    _context2.next = 12;
                    return index;

                case 12:
                    index++;
                    _context2.next = 5;
                    break;

                case 15:
                case 'end':
                    return _context2.stop();
            }
        }
    }, __chunkify__, this);
});
var generator = exports.generator = function generator(start, final) {
    var options = arguments.length <= 2 || arguments[2] === undefined ? _options.DEFAULT_OPTIONS : arguments[2];

    (0, _utility.assertNumber)(start);
    (0, _utility.assertNumber)(final);
    return __chunkify__(start, final, (0, _options.parseOptions)(options));
};